<template src="./template.html"></template>
<script lang="ts">
// import { getModule } from "nuxt-property-decorator";
import { title } from "process";
import { Vue, Component, Prop } from "vue-property-decorator";
import { apiErrorHandler } from "~/utils/apiHanlers";
import draggable from "vuedraggable";
import { Watch } from "nuxt-property-decorator";
// import axios from "axios";
// import UserModule from "~/store/user";
// import { Store } from "vuex";
const message = [
  "vue.draggable",
  "draggable",
  "component",
  "for",
  "vue.js 2.0",
  "based",
  "on",
  "Sortablejs",
];
import { api } from "~/common/constaint";
@Component({
  components: {
    draggable,
    MediaPicker: () => import("@/components/Seller/Store/Gallery/index.vue"),
  },
})
export default class SettingSellerMediaStoreComponent extends Vue {
  drag = true;
  isShowUploadPhoto = true;
  dialogMediaPicker = false;
  isLoading = false;

  get storeId() {
    return this.$store.state.sellerStore.storeId;
  }
  get store() {
    return this.$store.state.sellerStore.store;
  }

  mediaSrc = "";

  picture = "";

  get listShowImage() {
    return this.store?.product?.listImageId || [];
  }

  set listShowImage(val: any) {
    this.$store.commit("sellerStore/setStoreProduct", { listImageId: val });
  }

  get listCoverId() {
    return this.$store.state.storeGallery.listCoverId || "";
  }

  onUploadImage() {
    //@ts-ignore
    this.$refs.fileImage.$refs.input.click();
  }
  async onChangeImage(image: any) {
    this.picture = image;
    this.createImageLogo(image);
  }

  convertImage(url: string) {
    // return `https://api-win.zshop.pro/${url}`;
    return `${api}/${url}`;
  }

  createImageLogo(image: any) {
    const reader = new FileReader();
    reader.onload = (e) => {
      //@ts-ignore
      this.mediaSrc = e.target.result;
    };
    reader.readAsDataURL(image);
  }

  onGetDetailStore() {
    this.$store.dispatch("sellerStore/onGetDetailStore", { ctx: this });
  }

  async onDeleteImg(id: any) {
    const storeId = this.$route.params.id;
    const payload = {
      listDeletedImageId: [id],
    };
    try {
      this.isLoading = true;
      await this.$api.store.delete(storeId, payload);
      this.$pushNotification.success("Delete success");
      this.onGetDetailStore();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.isLoading = false;
    }
  }

  isCloseAddImage = false;

  closeDialogMediaPicker() {
    this.dialogMediaPicker = false;
    this.isCloseAddImage = true;
  }
  openDialogMediaPicker() {
    this.dialogMediaPicker = true;
    this.isCloseAddImage = false;
  }

  @Watch("dialogMediaPicker")
  async changeImage(val: boolean) {
    if (!val && this.listCoverId && !this.isCloseAddImage) {
      try {
        this.isLoading = true;
        const storeId = this.$route.params.id;
        const payload = {
          listNewImageId: this.listCoverId.map((item: any) => item._id),
        };
        await this.$api.store.postMedia(storeId, payload);
        // await this.$store.dispatch("storeGallery/onGetListImgCategory", {
        //   ctx: this,
        //   storeId: storeId,
        // });
        this.onGetDetailStore();
        this.$pushNotification.success("Add success");
      } catch (error) {
        console.log("error :>> ", error);
        apiErrorHandler(error, this);
      } finally {
        this.isLoading = false;
      }
    }
  }
}
</script>
<style src="./style.scss" lang="scss" scoped></style>
